<template>
  <div>
    <form>
      <div class="form-row">
        <div class="form-group col-md-2">
          <label>Deprecation taking effect after</label>
          <input
            type="date"
            v-model="deprecatedAfter"
            :min="minDate"
            :max="MaxDate"
          />
        </div>
        <div class="form-group col-md-2">
          <label>Deprecation taking before</label>
          <input
            type="date"
            v-model="deprecatedBefore"
            :min="minDate"
            :max="MaxDate"
          />
        </div>
        <div class="form-group col-md-2">
          <label>Announced in Version</label>
          <multiselect
            v-model="announcedVersion"
            :options="allVersions"
            :customLabel="renderVersion"
            :allowEmpty="true"
          />
        </div>
      </div>
      <div class="form-row">
        <div
          class="form-group col-md-3"
          data-toggle="tooltip"
          data-placement="top"
          title="Search supports regular expressions."
        >
          <label>Fulltext search</label>
          <input
            class="form-control"
            placeholder="Search deprecation name and description"
            v-model="textSearch"
          />
        </div>
        <div class="form-group col-md-3">
          <label>Order By</label><br />
          <div class="btn-group" role="group" aria-label="Basic example">
            <select class="custom-select" v-model="orderKey">
              <option value="due">Due Date</option>
            </select>
            <button
              type="button"
              @click="order = order * -1"
              class="btn btn-outline-dark"
            >
              {{ order < 0 ? "Asc" : "Desc" }}
            </button>
          </div>
        </div>
      </div>
      Showing {{ filteredDeprecations.length }} of
      {{ deprecations.length }} deprecations
    </form>
    <table class="table table-hover table-striped features-table">
      <thead>
        <tr>
          <th>Deprecation taking effect on</th>
          <th>Description</th>
          <th>Announced in Release post of version</th>
        </tr>
      </thead>
      <tbody>
        <tr
          :key="deprecation.version + deprecation.description"
          v-for="deprecation in filteredDeprecations"
        >
          <td>{{ deprecation.due }}</td>
          <td>
            <strong>{{ deprecation.feature_name }}</strong
            ><br /><span v-html="deprecation.description"></span>
          </td>
          <td>{{ renderVersion(deprecation.version) }}</td>
        </tr>
      </tbody>
      <tfoot>
        <tr>
          <th>Deprecation taking effect on</th>
          <th>Description</th>
          <th>Announced in Release post of version</th>
        </tr>
      </tfoot>
    </table>
    Showing {{ filteredDeprecations.length }} of
    {{ deprecations.length }} deprecations
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

let searchDefaults = {
  order: 1,
  orderKey: "due",
  textSearch: "",
  deprecatedAfter: null,
  deprecatedBefore: null,
  announcedVersion: null,
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

export default {
  components: {
    Multiselect,
  },
  data() {
    return {
      data: [],
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./deprecations.json");

    this.data = await response.json();
    const params = new URLSearchParams(window.location.search);

    searchDefaults.deprecatedBefore = this.dates.slice(-1)[0];
    searchDefaults.deprecatedAfter = this.dates[0];

    console.log(this.dates);

    this.deprecatedBefore = searchDefaults.deprecatedBefore;
    this.deprecatedAfter = searchDefaults.deprecatedAfter;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }

      params.set("tab", "deprecations");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    renderVersion(version) {
      return version.replace(/_0?/, ".").replace(/^0/, "").replace(/_0?/, ".");
    },
  },
  computed: {
    allVersions() {
      return uniqAndSort(
        this.deprecations.map((deprecation) => deprecation.version).flat()
      );
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    deprecations() {
      return this.data.map(({ due, ...rest }) => {
        let retracted = true;
        if (due) {
          retracted = false;
          due = due.substr(0, 10);
        }
        return { ...rest, due, retracted };
      });
    },
    dates() {
      return this.deprecations.flatMap((x) => (x.due ? x.due : [])).sort();
    },
    maxDate() {
      return this.dates.slice(-1)[0];
    },
    minDate() {
      return this.dates[0];
    },
    filteredDeprecations() {
      return this.deprecations
        .filter((deprecation) => {
          let visible = true;

          if (visible && this.announcedVersion) {
            visible = visible && deprecation.version === this.announcedVersion;
          }

          if (visible && this.textSearch) {
            visible =
              visible &&
              (deprecation.feature_name
                .toLocaleLowerCase()
                .includes(this.searchLower) ||
                deprecation.description
                  .toLocaleLowerCase()
                  .includes(this.searchLower));
          }

          visible =
            visible &&
            deprecation.due <= this.deprecatedBefore &&
            this.deprecatedAfter <= deprecation.due;

          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
